/* globals describe, afterAll, beforeAll, test, expect, jest */
const CosmosDbDriver = require('../driver/CosmosDbDriver');

describe('CosmosDbDriver', () => {
  let cosmosDbDriver;

  jest.setTimeout(50000);

  beforeAll(async () => {
    cosmosDbDriver = new CosmosDbDriver({
      connectionString: 'AccountEndpoint=https://localhost:8081/;AccountKey=C2y6yDjf5/R+ob0N8A7Cgv30VRDJIWEHLM+4QDU5DE2nQ9nDuVTqobD4b8mGGyPMbIZnqyMsEcaGQy67XIw/Jw==',
      databaseId: 'Test',
      containerId: 'Test',
    });
    await cosmosDbDriver.createDatabaseIfNotExists(cosmosDbDriver.databaseId);
  });

  beforeEach(async () => {
    await cosmosDbDriver.createContainerIfNotExists(cosmosDbDriver.databaseId, cosmosDbDriver.containerId);
    await cosmosDbDriver.createItemIfNotExists({ 'id': '1', 'key': 'value' });
  });

  afterEach(async () => {
    await cosmosDbDriver.deleteContainer();
  });

  test('Query returns one result', async () => {
    let results = await cosmosDbDriver.query('SELECT * FROM c OFFSET 0 LIMIT 10', [])
    expect(JSON.parse(JSON.stringify(results))).toBeInstanceOf(Array);
    expect(JSON.parse(JSON.stringify(results))).toHaveLength(1);
  });
});
